<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\F900;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

//nesse tem uma coluna brasil que segundo a doc retorna sempre brasil que não tem no outro ai usar isso para diferenciar os subtype que sao os mesmos

class SubTypeNRF3_1_Classe extends Record {
    public $name = "score_empresa";

    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "code_cons",
            'position' => 5,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "tipo_bloco",
            'position' => 9,
            'size' => 1,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "data",
            'position' => 10,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "hora",
            'position' => 18,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "fator_brasil",
            'position' => 26,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "prinad_brasil",
            'position' => 29,
            'size' => 7,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "fator_regiao",
            'position' => 36,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "prinad_regiao",
            'position' => 39,
            'size' => 7,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "fator_uf",
            'position' => 46,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "prinad_uf",
            'position' => 49,
            'size' => 7,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "uf_matriz",
            'position' => 56,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "regiao",
            'position' => 58,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "brasil",
            'position' => 60,
            'size' => 10,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "filler",
            'position' => 70,
            'size' => 46,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
    ];

    public function __construct($values = null) {
        $this->createColumns();
        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();

        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['code_cons'] = substr($values, 4, 4);
        $newValues['tipo_bloco'] = substr($values, 8, 1);
        $newValues['data'] = substr($values, 9, 8);
        $newValues['hora'] = substr($values, 17, 8);
        $newValues['fator_brasil'] = substr($values, 25, 3);
        $newValues['prinad_brasil'] = substr($values, 28, 7);
        $newValues['fator_regiao'] = substr($values, 35, 3);
        $newValues['prinad_regiao'] = substr($values, 38, 7);
        $newValues['fator_uf'] = substr($values, 45, 3);
        $newValues['prinad_uf'] = substr($values, 48, 7);
        $newValues['uf_matriz'] = substr($values, 55, 2);
        $newValues['regiao'] = substr($values, 57, 2);
        $newValues['brasil'] = substr($values, 59, 10);
        $newValues['filler'] = substr($values, 69, 46);

        $this->setColumnsValues($newValues);
    }
}