<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\F900;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypesQSCN_1 extends Record {
    public $name = "spc";

    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "cod_cons",
            'position' => 5,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "bloco",
            'position' => 9,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "tp_pessoa",
            'position' => 11,
            'size' => 9,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "docto",
            'position' => 12,
            'size' => 9,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "dig_docto",
            'position' => 21,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "nome",
            'position' => 23,
            'size' => 65,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "nac",
            'position' => 88,
            'size' => 12,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "per_cap",
            'position' => 100,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "dt_entr_soc",
            'position' => 104,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "filial",
            'position' => 112,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
    ];

    public function __construct($values = null) {
        $this->createColumns();
        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['cod_cons'] = substr($values, 4, 4);
        $newValues['bloco'] = substr($values, 8, 2);
        $newValues['tp_pessoa'] = substr($values, 10, 9);
        $newValues['docto'] = substr($values, 11, 9);
        $newValues['dig_docto'] = substr($values, 20, 2);
        $newValues['nome'] = substr($values, 22, 65);
        $newValues['nac'] = substr($values, 87, 12);
        $newValues['per_cap'] = substr($values, 99, 4);
        $newValues['dt_entr_soc'] = substr($values, 103, 8);
        $newValues['filial'] = substr($values, 111, 4);
        
        $this->setColumnsValues($newValues);
    }
}