<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\F900;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypeRECA_1 extends Record {
    public $name = "riskscoring_value_calc";
    
    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "cod_cons",
            'position' => 5,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "subtipo",
            'position' => 9,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "dtref",
            'position' => 11,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "perfx1",
            'position' => 19,
            'size' => 5,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "valfx1",
            'position' => 24,
            'size' => 17,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "perfx2",
            'position' => 41,
            'size' => 5,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "valfx2",
            'position' => 46,
            'size' => 17,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "perfx3",
            'position' => 63,
            'size' => 5,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "valfx3",
            'position' => 68,
            'size' => 17,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "perfx4",
            'position' => 85,
            'size' => 5,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "valfx4",
            'position' => 90,
            'size' => 17,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "filler",
            'position' => 107,
            'size' => 9,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
    ];

    public function __construct($values = null) {
        $this->createColumns();
        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['cod_cons'] = substr($values, 4, 4);
        $newValues['subtipo'] = substr($values, 8, 2);
        $newValues['dtref'] = substr($values, 10, 8);
        $newValues['perfx1'] = substr($values, 18, 5);
        $newValues['valfx1'] = substr($values, 23, 17);
        $newValues['perfx2'] = substr($values, 40, 5);
        $newValues['valfx2'] = substr($values, 45, 17);
        $newValues['perfx3'] = substr($values, 62, 5);
        $newValues['valfx3'] = substr($values, 67, 17);
        $newValues['perfx4'] = substr($values, 84, 5);
        $newValues['valfx4'] = substr($values, 89, 17);
        $newValues['filler'] = substr($values, 106, 9);
        
        $this->setColumnsValues($newValues);
    }
}